; *********************************************************************
; ****           Include file : emulates SC/MP processor           ****
; *********************************************************************

; **********************************************************************
; ****                          Data Block                          ****
; **********************************************************************
data segment
_A         db   ?,?
_E         db   ?,?
_S         db   ?,?
_P0        dw   ?
_P1        dw   ?
_P2        dw   ?
_P3        dw   ?
_Memory    db   4096 dup(?)
_Cycles    dw   ?
code segment
; *********************************************************************
; ****                         SC/MP Reset                         ****
; *********************************************************************
CPUReset:
    mov [dword ptr _A],0
    mov [dword ptr _E],0
    mov [dword ptr _S],0
    mov [dword ptr _P0],0
    mov [dword ptr _P1],0
    mov [dword ptr _P2],0
    mov [dword ptr _P3],0
    mov [dword ptr _Cycles],0
    ret
; *********************************************************************
; ****                         Read Memory                         ****
; *********************************************************************
CPURead:
    and bh,0Fh
    mov al,[_Memory+bx]
    ret
; *********************************************************************
; ****                      ldi .1 Opcode $C4                      ****
; *********************************************************************
    even
__Opcc4:
    add [_Cycles],10
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; **********************************************************************
; ****                        lde Opcode $40                        ****
; **********************************************************************
    even
__Opc40:
    add [_Cycles],6
    mov al,[_E]
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; **********************************************************************
; ****                       ld .2 Opcode $C0                       ****
; **********************************************************************
    even
__Opcc0:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1000
    mov al,[_E]
    cbw
__Usr1000:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; *********************************************************************
; ****                     ld .1(1) Opcode $C1                     ****
; *********************************************************************
    even
__Opcc1:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1001
    mov al,[_E]
    cbw
__Usr1001:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; *********************************************************************
; ****                     ld .1(2) Opcode $C2                     ****
; *********************************************************************
    even
__Opcc2:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1002
    mov al,[_E]
    cbw
__Usr1002:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; *********************************************************************
; ****                     ld .1(3) Opcode $C3                     ****
; *********************************************************************
    even
__Opcc3:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1003
    mov al,[_E]
    cbw
__Usr1003:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    ret

; **********************************************************************
; ****                     ld @.1(1) Opcode $C5                     ****
; **********************************************************************
    even
__Opcc5:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1006
    mov al,[_E]
    cbw
__Usr1006:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1004
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1004:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1005
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1005:
    ret

; **********************************************************************
; ****                     ld @.1(2) Opcode $C6                     ****
; **********************************************************************
    even
__Opcc6:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1009
    mov al,[_E]
    cbw
__Usr1009:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1007
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1007:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1008
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1008:
    ret

; **********************************************************************
; ****                     ld @.1(3) Opcode $C7                     ****
; **********************************************************************
    even
__Opcc7:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1012
    mov al,[_E]
    cbw
__Usr1012:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1010
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1010:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- ld operation AL -> Accumulator ---
    mov [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1011
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1011:
    ret

; **********************************************************************
; ****                       st .2 Opcode $C8                       ****
; **********************************************************************
    even
__Opcc8:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1013
    mov al,[_E]
    cbw
__Usr1013:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; *********************************************************************
; ****                     st .1(1) Opcode $C9                     ****
; *********************************************************************
    even
__Opcc9:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1014
    mov al,[_E]
    cbw
__Usr1014:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; *********************************************************************
; ****                     st .1(2) Opcode $CA                     ****
; *********************************************************************
    even
__Opcca:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1015
    mov al,[_E]
    cbw
__Usr1015:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; *********************************************************************
; ****                     st .1(3) Opcode $CB                     ****
; *********************************************************************
    even
__Opccb:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1016
    mov al,[_E]
    cbw
__Usr1016:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     st @.1(1) Opcode $CD                     ****
; **********************************************************************
    even
__Opccd:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1019
    mov al,[_E]
    cbw
__Usr1019:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1017
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1017:
    mov bx,[_P1]
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    pop bx
    test bh,080h
    jnz  __Usr1018
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1018:
    ret

; **********************************************************************
; ****                     st @.1(2) Opcode $CE                     ****
; **********************************************************************
    even
__Opcce:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1022
    mov al,[_E]
    cbw
__Usr1022:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1020
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1020:
    mov bx,[_P2]
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    pop bx
    test bh,080h
    jnz  __Usr1021
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1021:
    ret

; **********************************************************************
; ****                     st @.1(3) Opcode $CF                     ****
; **********************************************************************
    even
__Opccf:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1025
    mov al,[_E]
    cbw
__Usr1025:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1023
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1023:
    mov bx,[_P3]
    mov al,[_A]
;   --- Write 8 byte value in register al ---
    call WriteMemory
    pop bx
    test bh,080h
    jnz  __Usr1024
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1024:
    ret

; *********************************************************************
; ****                      ani .1 Opcode $D4                      ****
; *********************************************************************
    even
__Opcd4:
    add [_Cycles],10
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; **********************************************************************
; ****                        ane Opcode $50                        ****
; **********************************************************************
    even
__Opc50:
    add [_Cycles],6
    mov al,[_E]
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; *********************************************************************
; ****                      and .2 Opcode $D0                      ****
; *********************************************************************
    even
__Opcd0:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1026
    mov al,[_E]
    cbw
__Usr1026:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; **********************************************************************
; ****                     and .1(1) Opcode $D1                     ****
; **********************************************************************
    even
__Opcd1:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1027
    mov al,[_E]
    cbw
__Usr1027:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; **********************************************************************
; ****                     and .1(2) Opcode $D2                     ****
; **********************************************************************
    even
__Opcd2:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1028
    mov al,[_E]
    cbw
__Usr1028:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; **********************************************************************
; ****                     and .1(3) Opcode $D3                     ****
; **********************************************************************
    even
__Opcd3:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1029
    mov al,[_E]
    cbw
__Usr1029:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    ret

; *********************************************************************
; ****                    and @.1(1) Opcode $D5                    ****
; *********************************************************************
    even
__Opcd5:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1032
    mov al,[_E]
    cbw
__Usr1032:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1030
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1030:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1031
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1031:
    ret

; *********************************************************************
; ****                    and @.1(2) Opcode $D6                    ****
; *********************************************************************
    even
__Opcd6:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1035
    mov al,[_E]
    cbw
__Usr1035:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1033
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1033:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1034
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1034:
    ret

; *********************************************************************
; ****                    and @.1(3) Opcode $D7                    ****
; *********************************************************************
    even
__Opcd7:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1038
    mov al,[_E]
    cbw
__Usr1038:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1036
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1036:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- and operation AL -> Accumulator ---
    and [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1037
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1037:
    ret

; *********************************************************************
; ****                      ori .1 Opcode $DC                      ****
; *********************************************************************
    even
__Opcdc:
    add [_Cycles],10
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; **********************************************************************
; ****                        ore Opcode $58                        ****
; **********************************************************************
    even
__Opc58:
    add [_Cycles],6
    mov al,[_E]
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; **********************************************************************
; ****                       or .2 Opcode $D8                       ****
; **********************************************************************
    even
__Opcd8:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1039
    mov al,[_E]
    cbw
__Usr1039:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; *********************************************************************
; ****                     or .1(1) Opcode $D9                     ****
; *********************************************************************
    even
__Opcd9:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1040
    mov al,[_E]
    cbw
__Usr1040:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; *********************************************************************
; ****                     or .1(2) Opcode $DA                     ****
; *********************************************************************
    even
__Opcda:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1041
    mov al,[_E]
    cbw
__Usr1041:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; *********************************************************************
; ****                     or .1(3) Opcode $DB                     ****
; *********************************************************************
    even
__Opcdb:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1042
    mov al,[_E]
    cbw
__Usr1042:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    ret

; **********************************************************************
; ****                     or @.1(1) Opcode $DD                     ****
; **********************************************************************
    even
__Opcdd:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1045
    mov al,[_E]
    cbw
__Usr1045:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1043
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1043:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1044
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1044:
    ret

; **********************************************************************
; ****                     or @.1(2) Opcode $DE                     ****
; **********************************************************************
    even
__Opcde:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1048
    mov al,[_E]
    cbw
__Usr1048:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1046
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1046:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1047
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1047:
    ret

; **********************************************************************
; ****                     or @.1(3) Opcode $DF                     ****
; **********************************************************************
    even
__Opcdf:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1051
    mov al,[_E]
    cbw
__Usr1051:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1049
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1049:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- or operation AL -> Accumulator ---
    or [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1050
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1050:
    ret

; *********************************************************************
; ****                      xri .1 Opcode $E4                      ****
; *********************************************************************
    even
__Opce4:
    add [_Cycles],10
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; **********************************************************************
; ****                        xre Opcode $60                        ****
; **********************************************************************
    even
__Opc60:
    add [_Cycles],6
    mov al,[_E]
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; *********************************************************************
; ****                      xor .2 Opcode $E0                      ****
; *********************************************************************
    even
__Opce0:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1052
    mov al,[_E]
    cbw
__Usr1052:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; **********************************************************************
; ****                     xor .1(1) Opcode $E1                     ****
; **********************************************************************
    even
__Opce1:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1053
    mov al,[_E]
    cbw
__Usr1053:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; **********************************************************************
; ****                     xor .1(2) Opcode $E2                     ****
; **********************************************************************
    even
__Opce2:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1054
    mov al,[_E]
    cbw
__Usr1054:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; **********************************************************************
; ****                     xor .1(3) Opcode $E3                     ****
; **********************************************************************
    even
__Opce3:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1055
    mov al,[_E]
    cbw
__Usr1055:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    ret

; *********************************************************************
; ****                    xor @.1(1) Opcode $E5                    ****
; *********************************************************************
    even
__Opce5:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1058
    mov al,[_E]
    cbw
__Usr1058:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1056
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1056:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1057
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1057:
    ret

; *********************************************************************
; ****                    xor @.1(2) Opcode $E6                    ****
; *********************************************************************
    even
__Opce6:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1061
    mov al,[_E]
    cbw
__Usr1061:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1059
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1059:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1060
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1060:
    ret

; *********************************************************************
; ****                    xor @.1(3) Opcode $E7                    ****
; *********************************************************************
    even
__Opce7:
    add [_Cycles],18
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1064
    mov al,[_E]
    cbw
__Usr1064:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1062
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1062:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- xor operation AL -> Accumulator ---
    xor [_A],al
    pop bx
    test bh,080h
    jnz  __Usr1063
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1063:
    ret

; *********************************************************************
; ****                      dai .1 Opcode $EC                      ****
; *********************************************************************
    even
__Opcec:
    add [_Cycles],15
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1065
    or  [_S],080h
__Usr1065:
    ret

; **********************************************************************
; ****                        dae Opcode $68                        ****
; **********************************************************************
    even
__Opc68:
    add [_Cycles],11
    mov al,[_E]
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1066
    or  [_S],080h
__Usr1066:
    ret

; *********************************************************************
; ****                      dad .2 Opcode $E8                      ****
; *********************************************************************
    even
__Opce8:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1067
    mov al,[_E]
    cbw
__Usr1067:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1068
    or  [_S],080h
__Usr1068:
    ret

; **********************************************************************
; ****                     dad .1(1) Opcode $E9                     ****
; **********************************************************************
    even
__Opce9:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1069
    mov al,[_E]
    cbw
__Usr1069:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1070
    or  [_S],080h
__Usr1070:
    ret

; **********************************************************************
; ****                     dad .1(2) Opcode $EA                     ****
; **********************************************************************
    even
__Opcea:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1071
    mov al,[_E]
    cbw
__Usr1071:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1072
    or  [_S],080h
__Usr1072:
    ret

; **********************************************************************
; ****                     dad .1(3) Opcode $EB                     ****
; **********************************************************************
    even
__Opceb:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1073
    mov al,[_E]
    cbw
__Usr1073:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1074
    or  [_S],080h
__Usr1074:
    ret

; *********************************************************************
; ****                    dad @.1(1) Opcode $ED                    ****
; *********************************************************************
    even
__Opced:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1077
    mov al,[_E]
    cbw
__Usr1077:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1075
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1075:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1078
    or  [_S],080h
__Usr1078:
    pop bx
    test bh,080h
    jnz  __Usr1076
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1076:
    ret

; *********************************************************************
; ****                    dad @.1(2) Opcode $EE                    ****
; *********************************************************************
    even
__Opcee:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1081
    mov al,[_E]
    cbw
__Usr1081:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1079
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1079:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1082
    or  [_S],080h
__Usr1082:
    pop bx
    test bh,080h
    jnz  __Usr1080
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1080:
    ret

; *********************************************************************
; ****                    dad @.1(3) Opcode $EF                    ****
; *********************************************************************
    even
__Opcef:
    add [_Cycles],23
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1085
    mov al,[_E]
    cbw
__Usr1085:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1083
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1083:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- dad operation AL -> Accumulator ---
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc al,[_A]
    daa
    mov [_A],al
;   --- Save Carry Flag ---
    jnc __Usr1086
    or  [_S],080h
__Usr1086:
    pop bx
    test bh,080h
    jnz  __Usr1084
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1084:
    ret

; *********************************************************************
; ****                      adi .1 Opcode $F4                      ****
; *********************************************************************
    even
__Opcf4:
    add [_Cycles],11
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1087
;   --- Save Carry Flag ---
    jnc __Usr1089
    or  [_S],080h
__Usr1089:
    or  [_S],040h
    jmp __Usr1088
__Usr1087:
;   --- Save Carry Flag ---
    jnc __Usr1090
    or  [_S],080h
__Usr1090:
__Usr1088:
    ret

; **********************************************************************
; ****                        ade Opcode $70                        ****
; **********************************************************************
    even
__Opc70:
    add [_Cycles],7
    mov al,[_E]
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1091
;   --- Save Carry Flag ---
    jnc __Usr1093
    or  [_S],080h
__Usr1093:
    or  [_S],040h
    jmp __Usr1092
__Usr1091:
;   --- Save Carry Flag ---
    jnc __Usr1094
    or  [_S],080h
__Usr1094:
__Usr1092:
    ret

; *********************************************************************
; ****                      add .2 Opcode $F0                      ****
; *********************************************************************
    even
__Opcf0:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1095
    mov al,[_E]
    cbw
__Usr1095:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1096
;   --- Save Carry Flag ---
    jnc __Usr1098
    or  [_S],080h
__Usr1098:
    or  [_S],040h
    jmp __Usr1097
__Usr1096:
;   --- Save Carry Flag ---
    jnc __Usr1099
    or  [_S],080h
__Usr1099:
__Usr1097:
    ret

; **********************************************************************
; ****                     add .1(1) Opcode $F1                     ****
; **********************************************************************
    even
__Opcf1:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1100
    mov al,[_E]
    cbw
__Usr1100:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1101
;   --- Save Carry Flag ---
    jnc __Usr1103
    or  [_S],080h
__Usr1103:
    or  [_S],040h
    jmp __Usr1102
__Usr1101:
;   --- Save Carry Flag ---
    jnc __Usr1104
    or  [_S],080h
__Usr1104:
__Usr1102:
    ret

; **********************************************************************
; ****                     add .1(2) Opcode $F2                     ****
; **********************************************************************
    even
__Opcf2:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1105
    mov al,[_E]
    cbw
__Usr1105:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1106
;   --- Save Carry Flag ---
    jnc __Usr1108
    or  [_S],080h
__Usr1108:
    or  [_S],040h
    jmp __Usr1107
__Usr1106:
;   --- Save Carry Flag ---
    jnc __Usr1109
    or  [_S],080h
__Usr1109:
__Usr1107:
    ret

; **********************************************************************
; ****                     add .1(3) Opcode $F3                     ****
; **********************************************************************
    even
__Opcf3:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1110
    mov al,[_E]
    cbw
__Usr1110:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1111
;   --- Save Carry Flag ---
    jnc __Usr1113
    or  [_S],080h
__Usr1113:
    or  [_S],040h
    jmp __Usr1112
__Usr1111:
;   --- Save Carry Flag ---
    jnc __Usr1114
    or  [_S],080h
__Usr1114:
__Usr1112:
    ret

; *********************************************************************
; ****                    add @.1(1) Opcode $F5                    ****
; *********************************************************************
    even
__Opcf5:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1117
    mov al,[_E]
    cbw
__Usr1117:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1115
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1115:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1118
;   --- Save Carry Flag ---
    jnc __Usr1120
    or  [_S],080h
__Usr1120:
    or  [_S],040h
    jmp __Usr1119
__Usr1118:
;   --- Save Carry Flag ---
    jnc __Usr1121
    or  [_S],080h
__Usr1121:
__Usr1119:
    pop bx
    test bh,080h
    jnz  __Usr1116
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1116:
    ret

; *********************************************************************
; ****                    add @.1(2) Opcode $F6                    ****
; *********************************************************************
    even
__Opcf6:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1124
    mov al,[_E]
    cbw
__Usr1124:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1122
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1122:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1125
;   --- Save Carry Flag ---
    jnc __Usr1127
    or  [_S],080h
__Usr1127:
    or  [_S],040h
    jmp __Usr1126
__Usr1125:
;   --- Save Carry Flag ---
    jnc __Usr1128
    or  [_S],080h
__Usr1128:
__Usr1126:
    pop bx
    test bh,080h
    jnz  __Usr1123
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1123:
    ret

; *********************************************************************
; ****                    add @.1(3) Opcode $F7                    ****
; *********************************************************************
    even
__Opcf7:
    add [_Cycles],19
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1131
    mov al,[_E]
    cbw
__Usr1131:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1129
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1129:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- add operation AL -> Accumulator ---
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1132
;   --- Save Carry Flag ---
    jnc __Usr1134
    or  [_S],080h
__Usr1134:
    or  [_S],040h
    jmp __Usr1133
__Usr1132:
;   --- Save Carry Flag ---
    jnc __Usr1135
    or  [_S],080h
__Usr1135:
__Usr1133:
    pop bx
    test bh,080h
    jnz  __Usr1130
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1130:
    ret

; *********************************************************************
; ****                      cai .1 Opcode $FC                      ****
; *********************************************************************
    even
__Opcfc:
    add [_Cycles],12
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1136
;   --- Save Carry Flag ---
    jnc __Usr1138
    or  [_S],080h
__Usr1138:
    or  [_S],040h
    jmp __Usr1137
__Usr1136:
;   --- Save Carry Flag ---
    jnc __Usr1139
    or  [_S],080h
__Usr1139:
__Usr1137:
    ret

; **********************************************************************
; ****                        cae Opcode $78                        ****
; **********************************************************************
    even
__Opc78:
    add [_Cycles],8
    mov al,[_E]
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1140
;   --- Save Carry Flag ---
    jnc __Usr1142
    or  [_S],080h
__Usr1142:
    or  [_S],040h
    jmp __Usr1141
__Usr1140:
;   --- Save Carry Flag ---
    jnc __Usr1143
    or  [_S],080h
__Usr1143:
__Usr1141:
    ret

; *********************************************************************
; ****                      cad .2 Opcode $F8                      ****
; *********************************************************************
    even
__Opcf8:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1144
    mov al,[_E]
    cbw
__Usr1144:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1145
;   --- Save Carry Flag ---
    jnc __Usr1147
    or  [_S],080h
__Usr1147:
    or  [_S],040h
    jmp __Usr1146
__Usr1145:
;   --- Save Carry Flag ---
    jnc __Usr1148
    or  [_S],080h
__Usr1148:
__Usr1146:
    ret

; **********************************************************************
; ****                     cad .1(1) Opcode $F9                     ****
; **********************************************************************
    even
__Opcf9:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1149
    mov al,[_E]
    cbw
__Usr1149:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1150
;   --- Save Carry Flag ---
    jnc __Usr1152
    or  [_S],080h
__Usr1152:
    or  [_S],040h
    jmp __Usr1151
__Usr1150:
;   --- Save Carry Flag ---
    jnc __Usr1153
    or  [_S],080h
__Usr1153:
__Usr1151:
    ret

; **********************************************************************
; ****                     cad .1(2) Opcode $FA                     ****
; **********************************************************************
    even
__Opcfa:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1154
    mov al,[_E]
    cbw
__Usr1154:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1155
;   --- Save Carry Flag ---
    jnc __Usr1157
    or  [_S],080h
__Usr1157:
    or  [_S],040h
    jmp __Usr1156
__Usr1155:
;   --- Save Carry Flag ---
    jnc __Usr1158
    or  [_S],080h
__Usr1158:
__Usr1156:
    ret

; **********************************************************************
; ****                     cad .1(3) Opcode $FB                     ****
; **********************************************************************
    even
__Opcfb:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1159
    mov al,[_E]
    cbw
__Usr1159:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1160
;   --- Save Carry Flag ---
    jnc __Usr1162
    or  [_S],080h
__Usr1162:
    or  [_S],040h
    jmp __Usr1161
__Usr1160:
;   --- Save Carry Flag ---
    jnc __Usr1163
    or  [_S],080h
__Usr1163:
__Usr1161:
    ret

; *********************************************************************
; ****                    cad @.1(1) Opcode $FD                    ****
; *********************************************************************
    even
__Opcfd:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1166
    mov al,[_E]
    cbw
__Usr1166:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1164
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1164:
    mov bx,[_P1]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1167
;   --- Save Carry Flag ---
    jnc __Usr1169
    or  [_S],080h
__Usr1169:
    or  [_S],040h
    jmp __Usr1168
__Usr1167:
;   --- Save Carry Flag ---
    jnc __Usr1170
    or  [_S],080h
__Usr1170:
__Usr1168:
    pop bx
    test bh,080h
    jnz  __Usr1165
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P1],bx
__Usr1165:
    ret

; *********************************************************************
; ****                    cad @.1(2) Opcode $FE                    ****
; *********************************************************************
    even
__Opcfe:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1173
    mov al,[_E]
    cbw
__Usr1173:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1171
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1171:
    mov bx,[_P2]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1174
;   --- Save Carry Flag ---
    jnc __Usr1176
    or  [_S],080h
__Usr1176:
    or  [_S],040h
    jmp __Usr1175
__Usr1174:
;   --- Save Carry Flag ---
    jnc __Usr1177
    or  [_S],080h
__Usr1177:
__Usr1175:
    pop bx
    test bh,080h
    jnz  __Usr1172
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P2],bx
__Usr1172:
    ret

; *********************************************************************
; ****                    cad @.1(3) Opcode $FF                    ****
; *********************************************************************
    even
__Opcff:
    add [_Cycles],20
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1180
    mov al,[_E]
    cbw
__Usr1180:
    mov bx,ax
    push bx
    test bh,080h
    jz   __Usr1178
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1178:
    mov bx,[_P3]
;   --- Read 8 byte value to register al ---
    call ReadMemory
;   --- cad operation AL -> Accumulator ---
    xor al,255
    and [_S],0BFh
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    adc [_A],al
    jno __Usr1181
;   --- Save Carry Flag ---
    jnc __Usr1183
    or  [_S],080h
__Usr1183:
    or  [_S],040h
    jmp __Usr1182
__Usr1181:
;   --- Save Carry Flag ---
    jnc __Usr1184
    or  [_S],080h
__Usr1184:
__Usr1182:
    pop bx
    test bh,080h
    jnz  __Usr1179
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov  [_P3],bx
__Usr1179:
    ret

; *********************************************************************
; ****                      ild .2 Opcode $A8                      ****
; *********************************************************************
    even
__Opca8:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1185
    mov al,[_E]
    cbw
__Usr1185:
    mov bx,ax
    add bx,[_P0]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    inc al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     ild .1(1) Opcode $A9                     ****
; **********************************************************************
    even
__Opca9:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1186
    mov al,[_E]
    cbw
__Usr1186:
    mov bx,ax
    add bx,[_P1]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    inc al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     ild .1(2) Opcode $AA                     ****
; **********************************************************************
    even
__Opcaa:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1187
    mov al,[_E]
    cbw
__Usr1187:
    mov bx,ax
    add bx,[_P2]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    inc al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     ild .1(3) Opcode $AB                     ****
; **********************************************************************
    even
__Opcab:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1188
    mov al,[_E]
    cbw
__Usr1188:
    mov bx,ax
    add bx,[_P3]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    inc al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; *********************************************************************
; ****                      dld .2 Opcode $B8                      ****
; *********************************************************************
    even
__Opcb8:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1189
    mov al,[_E]
    cbw
__Usr1189:
    mov bx,ax
    add bx,[_P0]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    dec al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     dld .1(1) Opcode $B9                     ****
; **********************************************************************
    even
__Opcb9:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1190
    mov al,[_E]
    cbw
__Usr1190:
    mov bx,ax
    add bx,[_P1]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    dec al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     dld .1(2) Opcode $BA                     ****
; **********************************************************************
    even
__Opcba:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1191
    mov al,[_E]
    cbw
__Usr1191:
    mov bx,ax
    add bx,[_P2]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    dec al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; **********************************************************************
; ****                     dld .1(3) Opcode $BB                     ****
; **********************************************************************
    even
__Opcbb:
    add [_Cycles],22
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1192
    mov al,[_E]
    cbw
__Usr1192:
    mov bx,ax
    add bx,[_P3]
    push bx
;   --- Read 8 byte value to register al ---
    call ReadMemory
    dec al
    mov [_A],al
    pop bx
;   --- Write 8 byte value in register al ---
    call WriteMemory
    ret

; *********************************************************************
; ****                      jmp .3 Opcode $90                      ****
; *********************************************************************
    even
__Opc90:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1194
    mov al,[_E]
    cbw
__Usr1194:
    mov bx,ax
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1193:
    ret

; **********************************************************************
; ****                       jp .3 Opcode $94                       ****
; **********************************************************************
    even
__Opc94:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1196
    mov al,[_E]
    cbw
__Usr1196:
    mov bx,ax
    test [_A],080h
    jnz  __Usr1195
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1195:
    ret

; **********************************************************************
; ****                       jz .3 Opcode $98                       ****
; **********************************************************************
    even
__Opc98:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1198
    mov al,[_E]
    cbw
__Usr1198:
    mov bx,ax
    cmp  [_A],0h
    jnz  __Usr1197
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1197:
    ret

; *********************************************************************
; ****                      jnz .3 Opcode $9C                      ****
; *********************************************************************
    even
__Opc9c:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1200
    mov al,[_E]
    cbw
__Usr1200:
    mov bx,ax
    cmp  [_A],0h
    jz   __Usr1199
    mov cx,[_P0]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1199:
    ret

; **********************************************************************
; ****                     jmp .1(1) Opcode $91                     ****
; **********************************************************************
    even
__Opc91:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1202
    mov al,[_E]
    cbw
__Usr1202:
    mov bx,ax
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1201:
    ret

; *********************************************************************
; ****                     jp .1(1) Opcode $95                     ****
; *********************************************************************
    even
__Opc95:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1204
    mov al,[_E]
    cbw
__Usr1204:
    mov bx,ax
    test [_A],080h
    jnz  __Usr1203
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1203:
    ret

; *********************************************************************
; ****                     jz .1(1) Opcode $99                     ****
; *********************************************************************
    even
__Opc99:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1206
    mov al,[_E]
    cbw
__Usr1206:
    mov bx,ax
    cmp  [_A],0h
    jnz  __Usr1205
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1205:
    ret

; **********************************************************************
; ****                     jnz .1(1) Opcode $9D                     ****
; **********************************************************************
    even
__Opc9d:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1208
    mov al,[_E]
    cbw
__Usr1208:
    mov bx,ax
    cmp  [_A],0h
    jz   __Usr1207
    mov cx,[_P1]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1207:
    ret

; **********************************************************************
; ****                     jmp .1(2) Opcode $92                     ****
; **********************************************************************
    even
__Opc92:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1210
    mov al,[_E]
    cbw
__Usr1210:
    mov bx,ax
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1209:
    ret

; *********************************************************************
; ****                     jp .1(2) Opcode $96                     ****
; *********************************************************************
    even
__Opc96:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1212
    mov al,[_E]
    cbw
__Usr1212:
    mov bx,ax
    test [_A],080h
    jnz  __Usr1211
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1211:
    ret

; *********************************************************************
; ****                     jz .1(2) Opcode $9A                     ****
; *********************************************************************
    even
__Opc9a:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1214
    mov al,[_E]
    cbw
__Usr1214:
    mov bx,ax
    cmp  [_A],0h
    jnz  __Usr1213
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1213:
    ret

; **********************************************************************
; ****                     jnz .1(2) Opcode $9E                     ****
; **********************************************************************
    even
__Opc9e:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1216
    mov al,[_E]
    cbw
__Usr1216:
    mov bx,ax
    cmp  [_A],0h
    jz   __Usr1215
    mov cx,[_P2]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1215:
    ret

; **********************************************************************
; ****                     jmp .1(3) Opcode $93                     ****
; **********************************************************************
    even
__Opc93:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1218
    mov al,[_E]
    cbw
__Usr1218:
    mov bx,ax
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1217:
    ret

; *********************************************************************
; ****                     jp .1(3) Opcode $97                     ****
; *********************************************************************
    even
__Opc97:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1220
    mov al,[_E]
    cbw
__Usr1220:
    mov bx,ax
    test [_A],080h
    jnz  __Usr1219
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1219:
    ret

; *********************************************************************
; ****                     jz .1(3) Opcode $9B                     ****
; *********************************************************************
    even
__Opc9b:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1222
    mov al,[_E]
    cbw
__Usr1222:
    mov bx,ax
    cmp  [_A],0h
    jnz  __Usr1221
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1221:
    ret

; **********************************************************************
; ****                     jnz .1(3) Opcode $9F                     ****
; **********************************************************************
    even
__Opc9f:
    add [_Cycles],9
;   --- Fetch an offset ---
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
    cbw
    cmp al,80h
    jne __Usr1224
    mov al,[_E]
    cbw
__Usr1224:
    mov bx,ax
    cmp  [_A],0h
    jz   __Usr1223
    mov cx,[_P3]
    add bx,cx
    and bh,0Fh
    and ch,0F0h
    or  bh,ch
    mov [_P0],bx
    add [_Cycles],2
__Usr1223:
    ret

; **********************************************************************
; ****                        xae Opcode $01                        ****
; **********************************************************************
    even
__Opc01:
    add [_Cycles],7
    mov  al,[_A]
    xchg al,[_E]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xpal 0 Opcode $30                      ****
; *********************************************************************
    even
__Opc30:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P0]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xpah 0 Opcode $34                      ****
; *********************************************************************
    even
__Opc34:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P0+1]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xppc 0 Opcode $3C                      ****
; *********************************************************************
    even
__Opc3c:
    add [_Cycles],7
    mov  ax,[_P0]
    xchg ax,[_P0]
    mov  [_P0],ax
    ret

; *********************************************************************
; ****                      xpal 1 Opcode $31                      ****
; *********************************************************************
    even
__Opc31:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P1]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xpah 1 Opcode $35                      ****
; *********************************************************************
    even
__Opc35:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P1+1]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xppc 1 Opcode $3D                      ****
; *********************************************************************
    even
__Opc3d:
    add [_Cycles],7
    mov  ax,[_P0]
    xchg ax,[_P1]
    mov  [_P0],ax
    ret

; *********************************************************************
; ****                      xpal 2 Opcode $32                      ****
; *********************************************************************
    even
__Opc32:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P2]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xpah 2 Opcode $36                      ****
; *********************************************************************
    even
__Opc36:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P2+1]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xppc 2 Opcode $3E                      ****
; *********************************************************************
    even
__Opc3e:
    add [_Cycles],7
    mov  ax,[_P0]
    xchg ax,[_P2]
    mov  [_P0],ax
    ret

; *********************************************************************
; ****                      xpal 3 Opcode $33                      ****
; *********************************************************************
    even
__Opc33:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P3]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xpah 3 Opcode $37                      ****
; *********************************************************************
    even
__Opc37:
    add [_Cycles],8
    mov  al,[_A]
    xchg al,[byte _P3+1]
    mov  [_A],al
    ret

; *********************************************************************
; ****                      xppc 3 Opcode $3F                      ****
; *********************************************************************
    even
__Opc3f:
    add [_Cycles],7
    mov  ax,[_P0]
    xchg ax,[_P3]
    mov  [_P0],ax
    ret

; *********************************************************************
; ****                       halt Opcode $00                       ****
; *********************************************************************
    even
__Opc00:
    add [_Cycles],8
    ret

; **********************************************************************
; ****                        ccl Opcode $02                        ****
; **********************************************************************
    even
__Opc02:
    add [_Cycles],5
    and [_S],7Fh
    ret

; **********************************************************************
; ****                        scl Opcode $03                        ****
; **********************************************************************
    even
__Opc03:
    add [_Cycles],5
    or  [_S],80h
    ret

; *********************************************************************
; ****                       dint Opcode $04                       ****
; *********************************************************************
    even
__Opc04:
    add [_Cycles],6
    and [_S],0F7h
    ret

; **********************************************************************
; ****                        ien Opcode $05                        ****
; **********************************************************************
    even
__Opc05:
    add [_Cycles],6
    or [_S],8
    ret

; **********************************************************************
; ****                        csa Opcode $06                        ****
; **********************************************************************
    even
__Opc06:
    add [_Cycles],5
    mov al,[_S]
    mov [_A],al
    ret

; **********************************************************************
; ****                        cas Opcode $07                        ****
; **********************************************************************
    even
__Opc07:
    add [_Cycles],6
    mov al,[_A]
    and al,0CFh
    mov [_S],al
    ret

; **********************************************************************
; ****                        nop Opcode $08                        ****
; **********************************************************************
    even
__Opc08:
    add [_Cycles],5
    ret

; *********************************************************************
; ****                      dly .1 Opcode $8F                      ****
; *********************************************************************
    even
__Opc8f:
    add [_Cycles],13
;   --- Fetch 8 byte value to register al ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov al,[_Memory+bx]
	call LongDelay
    mov ah,0
    mov bx,ax
    shl bx,9
    add bx,ax
    add bx,ax
    mov al,[_A]
    add bx,ax
    add bx,ax
    add [_Cycles],bx
    mov [_A],255
    ret

; **********************************************************************
; ****                        sio Opcode $19                        ****
; **********************************************************************
    even
__Opc19:
    add [_Cycles],5
    shr [_E],1
    ret

; *********************************************************************
; ****                        sr Opcode $1C                        ****
; *********************************************************************
    even
__Opc1c:
    add [_Cycles],5
    shr [_A],1
    ret

; **********************************************************************
; ****                        srl Opcode $1D                        ****
; **********************************************************************
    even
__Opc1d:
    add [_Cycles],5
    shr [_A],1
    mov al,[_S]
    and al,128
    or  [_A],al
    ret

; *********************************************************************
; ****                        rr Opcode $1E                        ****
; *********************************************************************
    even
__Opc1e:
    add [_Cycles],5
    ror [_A],1
    ret

; **********************************************************************
; ****                        rrl Opcode $1F                        ****
; **********************************************************************
    even
__Opc1f:
    add [_Cycles],5
;   --- Load Carry Flag & Clear it ---
    mov ah,[_S]
    and [_S],07Fh
    add ah,080h
    rcr [_A],1
;   --- Save Carry Flag ---
    jnc __Usr1225
    or  [_S],080h
__Usr1225:
    ret

; **********************************************************************
; ****            Fetch and Execute a single instruction            ****
; **********************************************************************
CPUExecute:
;   --- Fetch 8 byte value to register bl ---
    inc [_P0]
    mov bx,[_P0]
    and bh,0Fh
    mov bl,[_Memory+bx]
    xor  bh,bh
    add  bx,bx
    call [_Vector+bx]
    ret
__fail:
    ret
    ret
    even
_Vector:
    dw __Opc00,__Opc01,__Opc02,__Opc03,__Opc04,__Opc05,__Opc06,__Opc07
    dw __Opc08,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__Opc19,__fail ,__fail ,__Opc1c,__Opc1d,__Opc1e,__Opc1f
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc30,__Opc31,__Opc32,__Opc33,__Opc34,__Opc35,__Opc36,__Opc37
    dw __fail ,__fail ,__fail ,__fail ,__Opc3c,__Opc3d,__Opc3e,__Opc3f
    dw __Opc40,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc50,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc58,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc60,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc68,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc70,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opc78,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__Opc8f
    dw __Opc90,__Opc91,__Opc92,__Opc93,__Opc94,__Opc95,__Opc96,__Opc97
    dw __Opc98,__Opc99,__Opc9a,__Opc9b,__Opc9c,__Opc9d,__Opc9e,__Opc9f
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opca8,__Opca9,__Opcaa,__Opcab,__fail ,__fail ,__fail ,__fail 
    dw __fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail ,__fail 
    dw __Opcb8,__Opcb9,__Opcba,__Opcbb,__fail ,__fail ,__fail ,__fail 
    dw __Opcc0,__Opcc1,__Opcc2,__Opcc3,__Opcc4,__Opcc5,__Opcc6,__Opcc7
    dw __Opcc8,__Opcc9,__Opcca,__Opccb,__fail ,__Opccd,__Opcce,__Opccf
    dw __Opcd0,__Opcd1,__Opcd2,__Opcd3,__Opcd4,__Opcd5,__Opcd6,__Opcd7
    dw __Opcd8,__Opcd9,__Opcda,__Opcdb,__Opcdc,__Opcdd,__Opcde,__Opcdf
    dw __Opce0,__Opce1,__Opce2,__Opce3,__Opce4,__Opce5,__Opce6,__Opce7
    dw __Opce8,__Opce9,__Opcea,__Opceb,__Opcec,__Opced,__Opcee,__Opcef
    dw __Opcf0,__Opcf1,__Opcf2,__Opcf3,__Opcf4,__Opcf5,__Opcf6,__Opcf7
    dw __Opcf8,__Opcf9,__Opcfa,__Opcfb,__Opcfc,__Opcfd,__Opcfe,__Opcff
; generated 121 out of 256
_Disassembly:
    db 7,000h,"halt",0
    db 6,001h,"xae",0
    db 6,002h,"ccl",0
    db 6,003h,"scl",0
    db 7,004h,"dint",0
    db 6,005h,"ien",0
    db 6,006h,"csa",0
    db 6,007h,"cas",0
    db 6,008h,"nop",0
    db 6,019h,"sio",0
    db 5,01ch,"sr",0
    db 6,01dh,"srl",0
    db 5,01eh,"rr",0
    db 6,01fh,"rrl",0
    db 9,030h,"xpal 0",0
    db 9,031h,"xpal 1",0
    db 9,032h,"xpal 2",0
    db 9,033h,"xpal 3",0
    db 9,034h,"xpah 0",0
    db 9,035h,"xpah 1",0
    db 9,036h,"xpah 2",0
    db 9,037h,"xpah 3",0
    db 9,03ch,"xppc 0",0
    db 9,03dh,"xppc 1",0
    db 9,03eh,"xppc 2",0
    db 9,03fh,"xppc 3",0
    db 6,040h,"lde",0
    db 6,050h,"ane",0
    db 6,058h,"ore",0
    db 6,060h,"xre",0
    db 6,068h,"dae",0
    db 6,070h,"ade",0
    db 6,078h,"cae",0
    db 9,08fh,"dly .1",0
    db 9,090h,"jmp .3",0
    db 12,091h,"jmp .1(1)",0
    db 12,092h,"jmp .1(2)",0
    db 12,093h,"jmp .1(3)",0
    db 8,094h,"jp .3",0
    db 11,095h,"jp .1(1)",0
    db 11,096h,"jp .1(2)",0
    db 11,097h,"jp .1(3)",0
    db 8,098h,"jz .3",0
    db 11,099h,"jz .1(1)",0
    db 11,09ah,"jz .1(2)",0
    db 11,09bh,"jz .1(3)",0
    db 9,09ch,"jnz .3",0
    db 12,09dh,"jnz .1(1)",0
    db 12,09eh,"jnz .1(2)",0
    db 12,09fh,"jnz .1(3)",0
    db 9,0a8h,"ild .2",0
    db 12,0a9h,"ild .1(1)",0
    db 12,0aah,"ild .1(2)",0
    db 12,0abh,"ild .1(3)",0
    db 9,0b8h,"dld .2",0
    db 12,0b9h,"dld .1(1)",0
    db 12,0bah,"dld .1(2)",0
    db 12,0bbh,"dld .1(3)",0
    db 8,0c0h,"ld .2",0
    db 11,0c1h,"ld .1(1)",0
    db 11,0c2h,"ld .1(2)",0
    db 11,0c3h,"ld .1(3)",0
    db 9,0c4h,"ldi .1",0
    db 12,0c5h,"ld @.1(1)",0
    db 12,0c6h,"ld @.1(2)",0
    db 12,0c7h,"ld @.1(3)",0
    db 8,0c8h,"st .2",0
    db 11,0c9h,"st .1(1)",0
    db 11,0cah,"st .1(2)",0
    db 11,0cbh,"st .1(3)",0
    db 12,0cdh,"st @.1(1)",0
    db 12,0ceh,"st @.1(2)",0
    db 12,0cfh,"st @.1(3)",0
    db 9,0d0h,"and .2",0
    db 12,0d1h,"and .1(1)",0
    db 12,0d2h,"and .1(2)",0
    db 12,0d3h,"and .1(3)",0
    db 9,0d4h,"ani .1",0
    db 13,0d5h,"and @.1(1)",0
    db 13,0d6h,"and @.1(2)",0
    db 13,0d7h,"and @.1(3)",0
    db 8,0d8h,"or .2",0
    db 11,0d9h,"or .1(1)",0
    db 11,0dah,"or .1(2)",0
    db 11,0dbh,"or .1(3)",0
    db 9,0dch,"ori .1",0
    db 12,0ddh,"or @.1(1)",0
    db 12,0deh,"or @.1(2)",0
    db 12,0dfh,"or @.1(3)",0
    db 9,0e0h,"xor .2",0
    db 12,0e1h,"xor .1(1)",0
    db 12,0e2h,"xor .1(2)",0
    db 12,0e3h,"xor .1(3)",0
    db 9,0e4h,"xri .1",0
    db 13,0e5h,"xor @.1(1)",0
    db 13,0e6h,"xor @.1(2)",0
    db 13,0e7h,"xor @.1(3)",0
    db 9,0e8h,"dad .2",0
    db 12,0e9h,"dad .1(1)",0
    db 12,0eah,"dad .1(2)",0
    db 12,0ebh,"dad .1(3)",0
    db 9,0ech,"dai .1",0
    db 13,0edh,"dad @.1(1)",0
    db 13,0eeh,"dad @.1(2)",0
    db 13,0efh,"dad @.1(3)",0
    db 9,0f0h,"add .2",0
    db 12,0f1h,"add .1(1)",0
    db 12,0f2h,"add .1(2)",0
    db 12,0f3h,"add .1(3)",0
    db 9,0f4h,"adi .1",0
    db 13,0f5h,"add @.1(1)",0
    db 13,0f6h,"add @.1(2)",0
    db 13,0f7h,"add @.1(3)",0
    db 9,0f8h,"cad .2",0
    db 12,0f9h,"cad .1(1)",0
    db 12,0fah,"cad .1(2)",0
    db 12,0fbh,"cad .1(3)",0
    db 9,0fch,"cai .1",0
    db 13,0fdh,"cad @.1(1)",0
    db 13,0feh,"cad @.1(2)",0
    db 13,0ffh,"cad @.1(3)",0
    db 0,0,0
